<template>
    <div class="footer">
        <!-- Attachment Button, Message text field, Send Button -->
        <div class="chatbox-footer row">
            <div
                v-if="replyToMessage"
                class="middle-footer row justify-end q-px-sm"
            >
                <div class="col row items-center message-bubble">
                    <bubble-reply
                        class="col"
                        :repliedMessage="replyToMessage"
                    />
                </div>
                <div class="row items-center">
                    <q-btn
                        @click="$store.dispatch('chat/removeReply')"
                        flat
                        round
                        color="grey"
                        icon="close"
                    />
                </div>
            </div>
            <!-- Buttons inside attachment button -->
            <div
                v-if="
                    !isSelectMultiple &&
                    !isBottomOpen &&
                    isMediaOpen &&
                    !isAudioRecording
                "
                class="row items-center q-mb-sm"
            >
                <!-- Close Button -->
                <q-btn @click="isMediaOpen = false" flat round>
                    <q-icon size="sm" name="img:icons\cancel.svg"></q-icon>
                </q-btn>

                <!-- Image & Video -->
                <q-btn @click="mediaInput.$el.click()" flat round>
                    <q-icon size="sm" name="img:icons\media.png"></q-icon>

                    <q-tooltip v-text="$t('button.media')" />
                </q-btn>

                <!-- Document -->
                <q-btn @click="fileInput.$el.click()" flat round>
                    <q-icon size="sm" name="img:icons\document.png"></q-icon>

                    <q-tooltip v-text="$t('button.file')" />
                </q-btn>

                <!-- Audio -->
                <q-btn
                    @click="startRecordAudio"
                    flat
                    round
                    color="primary"
                    icon="mdi-microphone-outline"
                >
                    <q-tooltip v-text="$t('button.recordAudio')" />
                </q-btn>
            </div>
            <div
                v-if="
                    !isSelectMultiple &&
                    !isMediaOpen &&
                    !isBottomOpen &&
                    !isAudioRecording
                "
                class="row items-center"
            >
                <!-- Emoji Button -->
                <!-- <q-btn
                @click="isBottomOpen = true"
                flat
                round
                color="grey"
                icon="sentiment_satisfied_alt"
            /> -->
                <q-btn @click="isMediaOpen = true" flat round>
                    <q-icon name="img:icons\attachment.png"></q-icon>
                </q-btn>
            </div>

            <div v-if="isAudioRecording" class="row items-center q-mb-sm">
                <q-btn
                    @click="cancelRecordAudio"
                    flat
                    round
                    color="grey"
                    icon="close"
                />
                <div class="recording">
                    <q-icon name="mdi-microphone" color="red" size="xs" />
                    {{ $t('alerts.recording') }}
                    <span>{{ countdownText }}</span>
                </div>
                <q-btn
                    @click="stopRecordAudio"
                    flat
                    round
                    color="primary"
                    icon="send"
                />
            </div>

            <q-input
                ref="textField"
                bottom-slots
                dense
                outlined
                :label="'Enter a message '"
                class="chatbox-input col font-14"
                v-model="text"
                @keyup.enter="submit"
                hide-bottom-space
            >
                <template v-slot:after>
                    <q-btn @click="submit" round flat icon="send" />
                </template>
            </q-input>
        </div>

        <q-file
            accept="image/*,video/*"
            max-file-size="104857600"
            ref="mediaInput"
            v-model="medias"
            multiple
        />

        <q-file
            max-file-size="314572800"
            ref="fileInput"
            v-model="files"
            multiple
        />
    </div>
</template>

<script lang="ts">
import { defineComponent, computed, ref, onBeforeUnmount, watch } from 'vue';
import { useStore } from 'src/store';
import { MessageType } from 'src/services/enums/MessageType';
import generateRandomString from 'src/services/helpers/GenerateRandomString';
import { Conversation } from 'src/services/models/Conversation';
import { floor, debounce } from 'lodash';
import moment from 'moment';
import AlertCustomDialog from 'src/components/modals/AlertCustomDialog.vue';

// @ts-ignore
import MicRecorder from 'mic-recorder-to-mp3';

import { MessageCreateRequestBody } from 'src/services/requests/message/MessageCreateRequest';
import { File as FileModel, Message } from 'src/services/models/Message';
import BubbleReply from '../../components/chats/BubbleReply.vue';
import { useI18n } from 'vue-i18n';
import { useQuasar } from 'quasar';

export default defineComponent({
    name: 'Footer',
    props: {
        isPreview: {
            type: Boolean,
            default: false
        },
        initialText: {
            type: String
        }
    },
    components: {
        BubbleReply
    },
    emits: ['submit', 'textChanged', 'filesSelected', 'update'],
    setup(props, { emit }) {
        const { t } = useI18n({ useScope: 'global' });
        const $q = useQuasar();
        const store = useStore();
        const isMediaOpen = ref(false);
        const isBottomOpen = ref(false);
        const isAudioRecording = ref(false);
        const text = ref(props.initialText ?? '');
        const medias = ref<File[]>();
        const mediaInput = ref<any>();
        const fileInput = ref<any>();
        const files = ref<File[]>();
        const countdownText = ref('');
        const countdown = ref(62);

        const isSelectMultiple = computed(
            (): boolean => store.state.chat.isSelectMultiple
        );

        const conversation = computed<Conversation>(
            () => store.state.chat.selectedConversation as Conversation
        );

        const replyToMessage = computed(
            (): Message => store.state.chat.replyToMessage as Message
        );

        onBeforeUnmount(() => {
            audioRecorder.stop();
        });

        // Method
        const submit = () => {
            // Parse the text
            const newText = text.value;
            // Get mentionedUserIds
            let match;
            let mentionedUserIds: string[] = [];
            const mentionRegex = new RegExp(/\[\@(.+?)\@\]/gim);
            while (null != (match = mentionRegex.exec(newText))) {
                if (match[1] != 'all') {
                    mentionedUserIds.push(match[1]);
                }
            }

            // Create message body
            const body: MessageCreateRequestBody = {
                type: MessageType.TEXT,
                text: newText?.trim(),
                createdAt: new Date(),
                localId: generateRandomString(24),
                mentionedUserIds
            };

            /*             const status: any = {
                type: true,
                index: newText?.trim(),
            }; */

            // Handle virgin conversation without ID
            if (conversation.value?.id == conversation.value?.userId) {
                body.userId = conversation.value?.userId;
            } else {
                body.conversationId = conversation.value?.id;
            }

            if (replyToMessage.value) {
                body.repliedMessageId = replyToMessage.value.id;
            }

            // Clear textfield
            text.value = '';

            // Close bottom
            isBottomOpen.value = false;

            emit('submit', {
                body,
                repliedMessage: replyToMessage.value
            });
            emit('update', []);
            store.dispatch('chat/clearReplyToMessage');
        };

        ///////////////////////////////////////////////////// AUDIO ////////////////////////////////////////////////////
        let audioRecorder = new MicRecorder({
            bitRate: 128
        });

        let startRecordingAt = moment();
        const startRecordAudio = () => {
            countdown.value = 0;
            isAudioRecording.value = true;
            startRecordingAt = moment();
            audioRecorder.start().catch((err: any) => {
                isAudioRecording.value = false;
                console.error(err);
            });
        };

        const stopRecordAudio = () => {
            const conversationID =
                store.state.conversation.selectedConversationID;
            isAudioRecording.value = false;
            const minDuration = 2;

            const duration =
                moment().diff(startRecordingAt, 'milliseconds') / 1000;

            audioRecorder
                .stop()
                .getMp3()
                .then(async ([buffer, blob]: [BlobPart[], Blob]) => {
                    const file = new File(
                        buffer,
                        `${generateRandomString(24)}.mp3`,
                        {
                            type: blob.type,
                            lastModified: Date.now()
                        }
                    );

                    // Upload file
                    if (duration >= minDuration) {
                        const result: { url: string; path: string } =
                            await store.dispatch('file/upload', { file });
                        if (result.url) {
                            // Create message body
                            const body: MessageCreateRequestBody = {
                                conversationId: conversationID,
                                type: MessageType.AUDIO,
                                createdAt: new Date(),
                                localId: generateRandomString(24),
                                duration: duration,
                                filePath: result.path
                            };

                            store.dispatch('message/sendMessage', {
                                body,
                                file: {
                                    path: result.url,
                                    url: result.url
                                }
                            });
                        }
                    }
                })
                .catch(console.error);
        };

        const cancelRecordAudio = () => {
            isAudioRecording.value = false;
            audioRecorder.stop();
        };

        const resendPendingMessage = () => {
            store.dispatch('message/resendMessage');
        };

        const getFileSizeInMB = (size: number) => {
            return size * 0.000001;
        };

        // Watch

        watch(
            () => conversation.value.id,
            () => {
                cancelRecordAudio();
                text.value = '';
            }
        );

        watch(
            () => text.value,
            (newText: string) => {
                emit('textChanged', newText);
            }
        );

        watch(
            () => medias.value,
            (_files?: File[]) => {
                if (_files && _files.length > 0) {
                    const removeList: any = [];
                    let formattedFilesList = _files.map((_file: any) => {
                        let type: MessageType;
                        if (_file.type.includes('video/')) {
                            // Video max size is 50mb
                            if (getFileSizeInMB(_file.size) > 50) {
                                removeList.push(_file);
                            }
                            type = MessageType.VIDEO;
                        } else if (_file.type.includes('image/')) {
                            // Image max size is 2mb
                            if (getFileSizeInMB(_file.size) > 10) {
                                removeList.push(_file);
                            }
                            type = MessageType.IMAGE;
                        } else if (_file.type.includes('audio/')) {
                            // Audio max size is 10mb
                            if (getFileSizeInMB(_file.size) > 10) {
                                removeList.push(_file);
                            }
                            type = MessageType.AUDIO;
                        } else {
                            // File max size is 50mb
                            if (getFileSizeInMB(_file.size) > 50) {
                                removeList.push(_file);
                            }
                            type = MessageType.DOCUMENT;
                        }

                        return {
                            file: _file,
                            url: URL.createObjectURL(_file),
                            type,
                            text: text.value
                        };
                    });
                    // Show which file is unable to upload
                    if (removeList.length > 0) {
                        $q.dialog({
                            component: AlertCustomDialog,
                            componentProps: {
                                title: t('alerts.fileSizeExceed'),
                                message: '',
                                actions: false
                            }
                        });

                        formattedFilesList = [];
                    }

                    if (formattedFilesList.length > 0) {
                        emit('filesSelected', formattedFilesList);
                    }
                    emit('update', []);
                    medias.value = [];
                }
            }
        );

        watch(
            () => files.value,
            (_files?: File[]) => {
                if (_files && _files.length > 0) {
                    const removeList: any = [];

                    let formattedFilesList = _files.map((_file) => {
                        // File max size is 50mb
                        if (getFileSizeInMB(_file.size) > 50) {
                            removeList.push(_file);
                        }
                        return {
                            file: _file,
                            url: URL.createObjectURL(_file),
                            type: MessageType.DOCUMENT,
                            text: text.value
                        };
                    });

                    // Show which file is unable to upload
                    if (removeList.length > 0) {
                        $q.dialog({
                            component: AlertCustomDialog,
                            componentProps: {
                                title: t('alerts.fileSizeExceed'),
                                message: '',
                                actions: false
                            }
                        });

                        formattedFilesList = [];
                    }

                    if (formattedFilesList.length > 0) {
                        emit('filesSelected', formattedFilesList);
                    }
                    emit('update', []);

                    files.value = [];
                }
            }
        );

        watch(
            () => countdown.value,
            (seconds: number) => {
                if (isAudioRecording.value) {
                    if (seconds < 62) {
                        const minutes = seconds > 60 ? floor(seconds / 60) : 0;
                        const remainderSeconds = floor(seconds % 60);
                        countdownText.value = `0${minutes}:${remainderSeconds
                            .toString()
                            .padStart(2, '0')}`;

                        setTimeout(() => {
                            countdown.value++;
                        }, 1000);
                    } else {
                        stopRecordAudio();
                    }
                }
            }
        );

        window.addEventListener('offline', function () {
            console.log('offline');
        });

        window.addEventListener('online', function () {
            console.log('online');
            resendPendingMessage();
        });

        return {
            isSelectMultiple,
            isMediaOpen,
            isBottomOpen,
            isAudioRecording,
            submit,
            medias,
            text,
            mediaInput,
            fileInput,
            files,
            cancelRecordAudio,
            countdownText,
            startRecordAudio,
            stopRecordAudio,
            replyToMessage
        };
    }
});
</script>
